global.spacePacketID = argument1;

//All main networking stuff happens here
object_event_add(PlayerControl,ev_step,ev_step_end,'  
    //send gravity flip event
    if keyboard_check_pressed(global.down) && global.myself.object != -1 && !instance_exists(InGameMenuController) {
        var spaceBuffer;
        spaceBuffer = buffer_create();
        write_ubyte(spaceBuffer,ds_list_find_index(global.players,global.myself));
        PluginPacketSend(global.spacePacketID,spaceBuffer);
        buffer_destroy(spaceBuffer);
        if global.isHost {
            with(global.myself.object) {
                flip *= -1;
                currentWeapon.image_yscale *= -1;
                image_yscale *= -1;
                playsound(x,y,JumpSnd);
                //prevent getting stuck in the floor
                y += (2*sprite_get_yoffset(sprite_index)-sprite_get_bbox_bottom(sprite_index)-sprite_get_bbox_top(sprite_index))*flip;
            }
        }
    }
  
    //process gravity flip event
    if global.isHost {
        while(PluginPacketGetBuffer(global.spacePacketID) != -1) {
            var spaceBuffer, space_player;
            spaceBuffer = PluginPacketGetBuffer(global.spacePacketID);
            space_player = PluginPacketGetPlayer(global.spacePacketID);
            if space_player.object != -1 && instance_exists(space_player.object) {
                with(space_player.object) {
                    flip *= -1;
                    currentWeapon.image_yscale *= -1;
                    image_yscale *= -1;
                    playsound(x,y,JumpSnd);
                    //prevent getting stuck in the floor
                    y += (2*sprite_get_yoffset(sprite_index)-sprite_get_bbox_bottom(sprite_index)-sprite_get_bbox_top(sprite_index))*flip;
                }
                
                buffer_clear(spaceBuffer);
                write_ubyte(spaceBuffer, ds_list_find_index(global.players,space_player));
                PluginPacketSend(global.spacePacketID,spaceBuffer);
            }
            
            buffer_destroy(spaceBuffer);
            PluginPacketPop(global.spacePacketID);
        }
    } else {
        while(PluginPacketGetBuffer(global.spacePacketID) != -1) {
            var spaceBuffer, space_player;
            spaceBuffer = PluginPacketGetBuffer(global.spacePacketID);
            space_player = ds_list_find_value(global.players,read_ubyte(spaceBuffer));
            if space_player != -1 {
                if space_player.object != -1 && instance_exists(space_player.object) {
                    with(space_player.object) {
                        flip *= -1;
                        currentWeapon.image_yscale *= -1;
                        image_yscale *= -1;
                        playsound(x,y,JumpSnd);
                        //prevent getting stuck in the floor
                        y += (2*sprite_get_yoffset(sprite_index)-sprite_get_bbox_bottom(sprite_index)-sprite_get_bbox_top(sprite_index))*flip;
                    }
                }
            }        
            buffer_destroy(spaceBuffer);
            PluginPacketPop(global.spacePacketID);
        }
    }
');

object_event_add(Character,ev_create,0,'
    flip = 1;
    animationImage2 = 0;
');
object_event_add(Character,ev_step,ev_step_normal,'
    //scout has infinite double jumps
    doublejumpUsed = false;
    
    //update the stab animation
    with(StabAnim) {
        if ownerPlayer == other.player image_yscale=other.flip;
    }
    
    speed = max(speed, -15);
    
    //flip sentries
    if player.sentry != noone && instance_exists(player.sentry) {
        with(player.sentry) {
            if !variable_local_exists("flip") {
                flip = other.flip;
                image_yscale *= flip;
            }
        }
    }
    if flip != 1 {
        //change gravity
        if(place_free(x,y+1)) {
            vspeed -= 0.6;
        }
        if (place_free(x,y-1)) {
            vspeed -= 0.6;
            if(vspeed<-10) vspeed=-10;
        } else {
            moveStatus = 0;
        }
    }
    
    if(abs(hspeed)<0.195 ) {
        animationImage2 = 0;
    }
    
    //handle the walking animations here
    if place_free(x,y+1*flip) {
        animationImage2 = 1;
    }
    
    if (player.humiliated)
    {
        if (!place_free(x,y+1*flip) && hspeed == 0)
            animationImage2 = 0;
        else if place_free(x,y+1*flip)
            animationImage2 = 2;
        if (!place_free(x,y+1*flip) && hspeed != 0)
            animationImage2 = 1+((animationImage2-1+abs(hspeed)/20) mod CHARACTER_ANIMATION_LEN);
    }
    else
        animationImage2 = (animationImage2+abs(hspeed)/20) mod CHARACTER_ANIMATION_LEN;
        
    animationImage = animationImage2;
');

//hack the keybytes so you can jump on the ceiling and stuff
object_event_add(Character,ev_other,ev_user1,'
    if(pressedKeys & $80)
    {
        if(!place_free(x,y+1*flip) and place_free(x,y))
        {
            if(not stabbing)
            {
                playsound(x,y,JumpSnd);
                if flip == 1 vspeed = min(vspeed-jumpStrength, -jumpStrength);
                else vspeed = max(vspeed+jumpStrength, jumpStrength);
            }
        }
        else if(canDoublejump and !doublejumpUsed and ((vspeed > -jumpStrength && flip == 1) || (vspeed < jumpStrength && flip != 1)))
        {
            vspeed = -jumpStrength*flip;
            playsound(x,y,JumpSnd);
            doublejumpUsed = 1;
            moveStatus = 0;
        }
    }
    pressedKeys &= $7F; //remove jumping, that is handled here now.
    if pressedKeys & $80 show_message("yes");
');
    
//override the horizontal flipping and fix the weapon position
object_event_add(Character,ev_step,ev_step_end,'
    if flip != 1 && instance_exists(currentWeapon) currentWeapon.y = y-currentWeapon.yoffset*2;
');

//Make sentries work with flipped gravity
object_event_add(SentryTurret,ev_other,ev_user0,'
    flip = ownerPlayer.sentry.flip;
    image_yscale *= ownerPlayer.sentry.flip;
    yoffset *= ownerPlayer.sentry.flip;
');

object_event_add(Sentry,ev_step,ev_step_begin,'
    if image_yscale < 0 {
        if(place_free(x,y+1)) vspeed -= 0.6;
        if(place_free(x,y-1)) vspeed -= 0.6;
    }
');

//extra networking so flipped sentries are synced
object_event_add(Sentry,ev_other,ev_user12,'if(global.updateType == FULL_UPDATE) write_byte(global.serializeBuffer, flip+1);');
object_event_add(Sentry,ev_other,ev_user13,'
    if(global.updateType == FULL_UPDATE) {
        receiveCompleteMessage(global.serverSocket, 1, global.deserializeBuffer);
        flip = read_byte(global.deserializeBuffer)-1;
        if currentWeapon != noone && instance_exists(currentWeapon) {
            with(currentWeapon) {
                if !variable_local_exists("flip") {
                    image_yscale *= ownerPlayer.sentry.flip;
                    yoffset *= ownerPlayer.sentry.flip;
                }
            }
        }
    }
');

//more networking so flipped players are also synced
object_event_add(Character,ev_other,ev_user12,'if(global.updateType == FULL_UPDATE) write_byte(global.serializeBuffer, flip+1);');
object_event_add(Character,ev_other,ev_user13,'
    if(global.updateType == FULL_UPDATE) {
        receiveCompleteMessage(global.serverSocket, 1, global.deserializeBuffer);
        flip = read_byte(global.deserializeBuffer)-1;
    }
')

//more hacking so sentry gibs fall properly too B)
object_event_add(Sentry,ev_destroy,0,'
    if variable_local_exists("flip") {
        sentrygibs.flip = flip;
        sentrygibs.image_yscale *= flip;
    } else {
        sentrygibs.flip = 1;
    }
');

object_event_add(SentryGibs,ev_step,ev_step_begin,'
    if flip != 1 {
        if(place_free(x,y+1)) {
            vspeed -= 0.6;
        }
        if(place_free(x,y-1)) {
            vspeed -= 0.6;
        }
    }
');

//make bubbles work with flipped gravity
object_event_add(SpeechBubbleO,ev_step,ev_step_end,'
    image_yscale = owner.flip;
    if owner.flip != 1 {
        y = round(owner.y)+18;
    }
');

//gibs and blood don't have gravity in space
object_event_add(Gib,ev_step,ev_step_normal,'
    if(place_free(x,y+1)) {
          vspeed -= 0.7
    }
');
object_event_add(BloodDrop,ev_step,ev_step_normal,'
    if(!stick) {
        if(place_free(x,y+1)) {
            vspeed -= 0.4;
        }
    }
');
object_event_add(DeadGuy,ev_create,0,'flip = 0;');
object_event_add(DeadGuy,ev_step,ev_step_begin,'
    //My more animations plugin will throw an error without this line.
    if !variable_local_exists("flip") flip = 1;
    
    if flip != 1 {
        if(place_free(x,y+1)) vspeed -= 0.6;
        if(place_free(x,y-1)) vspeed -= 0.6;
    }
');

//flip dead bodies
object_event_add(Character,ev_destroy,0,'
    with(DeadGuy) {
        if alarm[0] == 300 && (sprite_index == other.sprite_index || sprite_index == other.haxxyStatue) {
            flip = other.flip;
            image_yscale *= other.flip;
            if flip != 1 y+=60;
        }
   }
');

//flip projectiles
object_event_add(Shot,ev_create,0,'flip = 0');
object_event_add(Needle,ev_create,0,'flip = 0');
object_event_add(Mine,ev_create,0,'flip = 0');

object_event_add(Medigun,ev_other,ev_user2,'
    with(Needle) {
        if ownerPlayer == other.ownerPlayer && flip == 0 flip = owner.flip;
    }
');
object_event_add(Minegun,ev_other,ev_user3,'
    with(Mine) {
        if ownerPlayer == other.ownerPlayer && flip == 0 flip = owner.flip;
    }
');
object_event_add(Minigun,ev_other,ev_user1,'
    with(Shot) {
        if ownerPlayer == other.ownerPlayer && flip == 0 flip = owner.flip;
    }
');
object_event_add(Scattergun,ev_other,ev_user3,'
    with(Shot) {
        if ownerPlayer == other.ownerPlayer && flip == 0 flip = owner.flip;
    }
');
object_event_add(Shotgun,ev_other,ev_user3,'
    with(Shot) {
        if ownerPlayer == other.ownerPlayer && flip == 0 flip = owner.flip;
    }
');
object_event_add(Revolver,ev_other,ev_user3,'
    with(Shot) {
        if ownerPlayer == other.ownerPlayer && flip == 0 flip = owner.flip;
    }
');

object_event_add(Shot,ev_step,ev_step_normal,'
    if flip != 1 {
        vspeed-=0.30;
    }
');
object_event_add(Needle,ev_step,ev_step_begin,'
    if flip != 1 {
        vspeed-=0.30;
    }
');
object_event_add(Mine,ev_step,ev_step_normal,'
    if flip != 1 && !stickied {
        vspeed -= 0.4;
        vspeed = max(vspeed,-8);
    }
');

//ps ajf likes whining
object_event_add(PlayerControl,ev_other,ev_room_start,'
    var obstacle;
    obstacle = instance_create(0,-16,Obstacle);
    obstacle.image_xscale = map_width()/16;
    
    obstacle = instance_create(0,map_height(),Obstacle);
    obstacle.image_xscale = map_width()/16;
    
    obstacle = instance_create(-16,0,Obstacle);
    obstacle.image_yscale = map_height()/16;
    
    obstacle = instance_create(map_width(),0,Obstacle);
    obstacle.image_yscale = map_height()/16;
    
');